diff --git a/test/unit/stages/review/fix_completion_fallback_test.rb b/test/unit/stages/review/fix_completion_fallback_test.rb
new file mode 100644
index 00000000..49a7faf1
--- /dev/null
+++ b/test/unit/stages/review/fix_completion_fallback_test.rb
@@ -0,0 +1,499 @@
+require "test_helper"
+require "hive/stages/review"
+require "hive/events"
+require "hive/claude_launcher"
+require "hive/task"
+
+class HiveStagesReviewFixCompletionFallbackTest < Minitest::Test
+  include HiveTestHelper
+
+  FakeTask = Struct.new(:folder, :slug, keyword_init: true)
+
+  def setup
+    @task_dir = Dir.mktmpdir("hive-review-fix-fallback")
+    @worktree = Dir.mktmpdir("hive-review-fix-wt")
+    system("git", "init", "-q", @worktree)
+    system("git", "-C", @worktree, "config", "user.email", "test@example.com")
+    system("git", "-C", @worktree, "config", "user.name", "Test")
+    File.write(File.join(@worktree, "README.md"), "seed\n")
+    system("git", "-C", @worktree, "add", "README.md")
+    system("git", "-C", @worktree, "commit", "-q", "-m", "seed")
+    @before_head = `git -C #{Shellwords.escape(@worktree)} rev-parse HEAD`.strip
+    @task = FakeTask.new(folder: @task_dir, slug: "demo-260629-fixfb")
+    FileUtils.mkdir_p(File.join(@task_dir, "reviews"))
+    @ctx = Hive::Stages::Review::Context.new(
+      worktree_path: @worktree,
+      task_folder: @task_dir,
+      default_branch: "main",
+      pass: 1
+    )
+  end
+
+  def teardown
+    FileUtils.rm_rf(@task_dir) if @task_dir
+    FileUtils.rm_rf(@worktree) if @worktree
+  end
+
+  def write_reviewer_file(name, body)
+    path = File.join(@task_dir, "reviews", name)
+    File.write(path, body)
+    path
+  end
+
+  def fallback_ok_result(extra = {})
+    {
+      status: :ok,
+      log_label: "review-fix-pass01",
+      stop_hook_signal: :missing,
+      completion_evidence: :ready_prompt,
+      final_message: nil
+    }.merge(extra)
+  end
+
+  def test_corroboration_accepts_head_advanced_with_artifacts
+    write_reviewer_file("code-review-01.md", <<~MD)
+      # Review
+
+      - [x] Fix the nil guard in foo.rb
+    MD
+    File.write(File.join(@worktree, "lib.rb"), "puts 1\n")
+    system("git", "-C", @worktree, "add", "lib.rb")
+    system("git", "-C", @worktree, "commit", "-q", "-m", "fix")
+
+    evidence = Hive::Stages::Review.send(
+      :fix_fallback_corroboration_evidence,
+      @ctx, fallback_ok_result, @before_head
+    )
+
+    assert evidence[:ok], "expected corroboration success, got #{evidence.inspect}"
+    assert_equal "head_advanced", evidence[:reason]
+  end
+
+  def test_corroboration_rejects_reset_to_older_commit_as_head_advance
+    File.write(File.join(@worktree, "second.rb"), "puts 2\n")
+    system("git", "-C", @worktree, "add", "second.rb")
+    system("git", "-C", @worktree, "commit", "-q", "-m", "pass start")
+    pass_start_head = Hive::Stages::AutoCommit.git_head(@worktree)
+    system("git", "-C", @worktree, "reset", "--hard", "HEAD^", out: File::NULL)
+    write_reviewer_file("code-review-01.md", "- [ ] Still needs a real fix\n")
+
+    evidence = Hive::Stages::Review.send(
+      :fix_fallback_corroboration_evidence,
+      @ctx, fallback_ok_result, pass_start_head
+    )
+
+    refute evidence[:ok], evidence.inspect
+    assert_equal "no_change_evidence", evidence[:reason]
+    refute_equal pass_start_head, evidence[:head]
+  end
+
+  def test_descendant_commit_check_fails_closed_when_ancestry_is_unreadable
+    refute Hive::Stages::Review.send(
+      :descendant_commit?, @worktree, "missing-pass-start", @before_head
+    )
+  end
+
+  def test_gate_accepts_fallback_and_emits_caller_event
+    write_reviewer_file("code-review-01.md", <<~MD)
+      - [x] Fix the nil guard in foo.rb
+    MD
+    File.write(File.join(@worktree, "lib.rb"), "puts 1\n")
+    system("git", "-C", @worktree, "add", "lib.rb")
+    system("git", "-C", @worktree, "commit", "-q", "-m", "fix")
+
+    result = Hive::Stages::Review.send(
+      :apply_fix_completion_fallback_gate!,
+      @task, @ctx, fallback_ok_result, before_fix_head: @before_head
+    )
+
+    assert_equal :ok, result.fetch(:status)
+    assert_equal :missing, result.fetch(:stop_hook_signal)
+    refute result.key?(:fallback_corroboration)
+
+    events = File.readlines(File.join(@task_dir, "events.jsonl"), chomp: true)
+    fallback = events.map { |line| JSON.parse(line) }
+                     .select { |e| e["event_type"] == "claude_completion_fallback" }
+    assert_equal 1, fallback.size
+    msg = fallback.first.fetch("message")
+    assert_includes msg, "phase=fix"
+    assert_includes msg, "pass=01"
+    assert_includes msg, "reason=head_advanced"
+    assert_includes msg, "artifacts=code-review-01.md"
+    assert_includes msg, "slug=demo-260629-fixfb"
+    assert_equal "review-fix-pass01", fallback.first.fetch("agent")
+  end
+
+  def test_corroboration_accepts_dirty_worktree
+    write_reviewer_file("code-review-01.md", "- [x] Fix something\n")
+    File.write(File.join(@worktree, "dirty.rb"), "x\n")
+
+    evidence = Hive::Stages::Review.send(
+      :fix_fallback_corroboration_evidence,
+      @ctx, fallback_ok_result, @before_head
+    )
+
+    assert evidence[:ok]
+    assert_equal "worktree_dirty", evidence[:reason]
+  end
+
+  def test_corroboration_accepts_all_findings_ticked_no_change
+    write_reviewer_file("code-review-01.md", <<~MD)
+      - [x] Already fixed upstream
+      - [x] Duplicate of prior pass
+    MD
+
+    evidence = Hive::Stages::Review.send(
+      :fix_fallback_corroboration_evidence,
+      @ctx, fallback_ok_result, @before_head
+    )
+
+    assert evidence[:ok], evidence.inspect
+    assert_equal "no_change", evidence[:reason]
+    assert evidence[:no_change]
+  end
+
+  def test_corroboration_accepts_explicit_no_change_final_message
+    write_reviewer_file("code-review-01.md", "- [ ] still open but agent said no changes\n")
+
+    result = fallback_ok_result(final_message: "No changes needed.")
+    evidence = Hive::Stages::Review.send(
+      :fix_fallback_corroboration_evidence,
+      @ctx, result, @before_head
+    )
+
+    assert evidence[:ok], evidence.inspect
+    assert_equal "no_change", evidence[:reason]
+  end
+
+  def test_corroboration_extracts_explicit_no_change_from_tmux_agent_response
+    write_reviewer_file("code-review-01.md", "- [ ] still open but agent said no changes\n")
+    pane = <<~PANE
+      Claude Code v2.1.179
+      ❯ Apply the accepted review findings.
+
+      ● No changes needed.
+
+      ─────────────────────────────────────────────────────────────
+      review-worktree main ❯
+      ─────────────────────────────────────────────────────────────
+      ⏵⏵ bypass permissions on (shift+tab to cycle) · ← for agents
+    PANE
+
+    result = fallback_ok_result(
+      final_message: pane,
+      final_message_source: :plain
+    )
+    evidence = Hive::Stages::Review.send(
+      :fix_fallback_corroboration_evidence,
+      @ctx, result, @before_head
+    )
+
+    assert evidence[:ok], evidence.inspect
+    assert_equal "no_change", evidence[:reason]
+  end
+
+  def test_corroboration_rejects_negated_quoted_or_echoed_no_change_text
+    write_reviewer_file("code-review-01.md", "- [ ] still open\n")
+
+    [
+      "It is not true that no changes needed.",
+      "The prompt said \"no changes needed\".",
+      "Instructions:\nRespond with no changes needed.\n❯",
+      "Reviewed the findings; no changes needed."
+    ].each do |message|
+      evidence = Hive::Stages::Review.send(
+        :fix_fallback_corroboration_evidence,
+        @ctx, fallback_ok_result(final_message: message), @before_head
+      )
+
+      refute evidence[:ok], "#{message.inspect} must not be affirmative isolated evidence"
+      assert_equal "no_change_evidence", evidence[:reason]
+    end
+  end
+
+  def test_gate_rejects_unchecked_findings_without_commit
+    write_reviewer_file("code-review-01.md", <<~MD)
+      - [ ] Still needs a real fix
+      - [x] Already done
+    MD
+
+    result = Hive::Stages::Review.send(
+      :apply_fix_completion_fallback_gate!,
+      @task, @ctx, fallback_ok_result, before_fix_head: @before_head
+    )
+
+    assert_equal :timeout, result.fetch(:status)
+    assert_equal Hive::ClaudeLauncher::STOP_HOOK_TIMEOUT_MESSAGE, result.fetch(:error_message)
+    assert_equal :failed, result.fetch(:fallback_corroboration)
+    assert_equal "no_change_evidence", result.fetch(:fallback_corroboration_reason)
+    # Healer contract: exact message for FIX_CLAUDE_STOP_HOOK_MESSAGE.
+    assert_equal "claude stop hook did not signal completion", result.fetch(:error_message)
+  end
+
+  def test_gate_rejects_unresolved_escalations
+    write_reviewer_file("code-review-01.md", "- [x] Accepted finding\n")
+    write_reviewer_file("escalations-01.md", <<~MD)
+      ### Q1. Should we change the API?
+      Source: code-review-01.md
+      Finding: break public API
+      ### A1.
+
+    MD
+    File.write(File.join(@worktree, "lib.rb"), "x\n")
+    system("git", "-C", @worktree, "add", "lib.rb")
+    system("git", "-C", @worktree, "commit", "-q", "-m", "fix")
+
+    result = Hive::Stages::Review.send(
+      :apply_fix_completion_fallback_gate!,
+      @task, @ctx, fallback_ok_result, before_fix_head: @before_head
+    )
+
+    assert_equal :timeout, result.fetch(:status)
+    assert_equal Hive::ClaudeLauncher::STOP_HOOK_TIMEOUT_MESSAGE, result.fetch(:error_message)
+    assert_equal "unresolved_escalations", result.fetch(:fallback_corroboration_reason)
+  end
+
+  def test_gate_rejects_unreadable_worktree
+    write_reviewer_file("code-review-01.md", "- [x] Fix something\n")
+    # Point ctx at a non-git directory so worktree_status returns the error Array.
+    bad_ctx = @ctx.with(worktree_path: @task_dir)
+
+    result = Hive::Stages::Review.send(
+      :apply_fix_completion_fallback_gate!,
+      @task, bad_ctx, fallback_ok_result, before_fix_head: @before_head
+    )
+
+    assert_equal :timeout, result.fetch(:status)
+    assert_equal Hive::ClaudeLauncher::STOP_HOOK_TIMEOUT_MESSAGE, result.fetch(:error_message)
+    assert_equal "worktree_unreadable", result.fetch(:fallback_corroboration_reason)
+  end
+
+  def test_gate_rejects_missing_artifacts
+    # No reviewer files for pass 01.
+    result = Hive::Stages::Review.send(
+      :apply_fix_completion_fallback_gate!,
+      @task, @ctx, fallback_ok_result, before_fix_head: @before_head
+    )
+
+    assert_equal :timeout, result.fetch(:status)
+    assert_equal "artifacts_missing_or_unreadable", result.fetch(:fallback_corroboration_reason)
+  end
+
+  def test_gate_rejects_an_expected_artifact_deleted_by_the_fix_agent
+    expected = write_reviewer_file("code-review-01.md", "- [x] Fix something\n")
+    File.delete(expected)
+
+    result = Hive::Stages::Review.send(
+      :apply_fix_completion_fallback_gate!,
+      @task, @ctx, fallback_ok_result,
+      before_fix_head: @before_head,
+      expected_artifacts: [ expected ]
+    )
+
+    assert_equal :timeout, result.fetch(:status)
+    assert_equal "artifacts_missing_or_unreadable", result.fetch(:fallback_corroboration_reason)
+  end
+
+  def test_gate_rejects_empty_and_malformed_artifact_replacements
+    expected = write_reviewer_file("code-review-01.md", "- [x] Fix something\n")
+
+    [
+      "",
+      "Claude stopped before producing a structured review.\n",
+      "## High\n",
+      "\xFF".b
+    ].each do |replacement|
+      File.write(expected, replacement)
+      result = Hive::Stages::Review.send(
+        :apply_fix_completion_fallback_gate!,
+        @task, @ctx, fallback_ok_result,
+        before_fix_head: @before_head,
+        expected_artifacts: [ expected ]
+      )
+
+      assert_equal :timeout, result.fetch(:status)
+      assert_equal "artifacts_missing_or_unreadable", result.fetch(:fallback_corroboration_reason)
+    end
+  end
+
+  def test_artifact_parser_accepts_structured_clean_review_sections
+    path = write_reviewer_file("code-review-01.md", <<~MD)
+      ## High
+      No findings.
+
+      ## Medium
+      No findings.
+    MD
+
+    assert Hive::Stages::Review.send(:artifacts_parseable?, [ path ])
+  end
+
+  def test_gate_skips_non_fallback_ok_results
+    write_reviewer_file("code-review-01.md", "- [x] x\n")
+
+    done_ok = { status: :ok, log_label: "review-fix-pass01", stop_hook_signal: :done_file }
+    result = Hive::Stages::Review.send(
+      :apply_fix_completion_fallback_gate!,
+      @task, @ctx, done_ok, before_fix_head: @before_head
+    )
+    assert_equal done_ok, result
+    refute File.exist?(File.join(@task_dir, "events.jsonl"))
+
+    crashed = {
+      status: :error,
+      error_message: Hive::ClaudeLauncher::STOP_HOOK_SESSION_TERMINATED_MESSAGE
+    }
+    result = Hive::Stages::Review.send(
+      :apply_fix_completion_fallback_gate!,
+      @task, @ctx, crashed, before_fix_head: @before_head
+    )
+    assert_equal crashed, result
+
+    timed_out = {
+      status: :timeout,
+      error_message: Hive::ClaudeLauncher::STOP_HOOK_TIMEOUT_MESSAGE
+    }
+    result = Hive::Stages::Review.send(
+      :apply_fix_completion_fallback_gate!,
+      @task, @ctx, timed_out, before_fix_head: @before_head
+    )
+    assert_equal timed_out, result
+  end
+
+  def test_agent_failed_still_true_for_demoted_fallback
+    demoted = {
+      status: :timeout,
+      error_message: Hive::ClaudeLauncher::STOP_HOOK_TIMEOUT_MESSAGE,
+      fallback_corroboration: :failed
+    }
+    assert Hive::Stages::Review.send(:agent_failed?, demoted)
+  end
+
+  def test_write_fix_success_path_unchanged_for_corroborated_ok
+    # Ensure write_fix_success still works for a corroborated path
+    # (same helper both .done and fallback success use).
+    Hive::Stages::Review.send(:write_fix_success, @ctx)
+    path = Hive::Stages::Review.fix_success_path(@task_dir, 1)
+    assert File.exist?(path)
+    assert_match(/Fix completed for pass 01/, File.read(path))
+  end
+
+
+  def test_run_accepts_corroborated_fallback_through_review_complete
+    with_full_review_run_task do |task, cfg, worktree|
+      accepted_seen = nil
+      fallback_result = fallback_ok_result
+      spawn = lambda do |_task, _cfg, _ctx, accepted:|
+        accepted_seen = accepted
+        File.write(File.join(worktree, "lib.rb"), "fixed = true\n")
+        Kernel.system("git", "-C", worktree, "add", "lib.rb")
+        Kernel.system("git", "-C", worktree, "commit", "-q", "-m", "fix")
+        fallback_result
+      end
+
+      result = nil
+      with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, spawn) do
+        result = Hive::Stages::Review.run!(task, cfg)
+      end
+
+      assert_includes accepted_seen, "Fix the nil guard"
+      assert_equal :review_complete, result.fetch(:status)
+      marker = Hive::Markers.current(task.state_file)
+      assert_equal :review_complete, marker.name
+      assert_equal "skipped", marker.attrs.fetch("browser")
+      assert File.exist?(Hive::Stages::Review.fix_success_path(task.folder, 1))
+      assert_equal "fix", IO.popen([ "git", "-C", worktree, "log", "-1", "--pretty=%s" ], &:read).strip
+
+      events = File.readlines(File.join(task.folder, "events.jsonl"), chomp: true)
+                   .map { |line| JSON.parse(line) }
+      assert events.any? { |event| event["event_type"] == "claude_completion_fallback" },
+             "full Review.run! success must retain caller-side fallback evidence"
+    end
+  end
+
+  def test_run_maps_missing_expected_artifact_to_review_error_fix_failed
+    with_full_review_run_task do |task, cfg, _worktree|
+      accepted_seen = nil
+      fallback_result = fallback_ok_result
+      spawn = lambda do |_task, _cfg, _ctx, accepted:|
+        accepted_seen = accepted
+        File.delete(File.join(task.reviews_dir, "code-review-01.md"))
+        fallback_result
+      end
+
+      result = nil
+      with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, spawn) do
+        result = Hive::Stages::Review.run!(task, cfg)
+      end
+
+      assert_includes accepted_seen, "Fix the nil guard"
+      assert_equal :review_error, result.fetch(:status)
+      marker = Hive::Markers.current(task.state_file)
+      assert_equal :review_error, marker.name
+      assert_equal "fix", marker.attrs.fetch("phase")
+      assert_equal "fix_failed", marker.attrs.fetch("reason")
+      assert_equal Hive::ClaudeLauncher::STOP_HOOK_TIMEOUT_MESSAGE,
+                   marker.attrs.fetch("message")
+      refute File.exist?(Hive::Stages::Review.fix_success_path(task.folder, 1))
+    end
+  end
+
+  private
+
+  def with_full_review_run_task
+    root = Dir.mktmpdir("hive-review-fallback-run")
+    project = File.join(root, "project")
+    task_folder = File.join(
+      project, ".hive-state", "stages", "6-review", "demo-260629-fixfb"
+    )
+    reviews = File.join(task_folder, "reviews")
+    worktree_root = File.join(root, "worktrees")
+    worktree = File.join(worktree_root, "demo-260629-fixfb")
+    FileUtils.mkdir_p([ reviews, worktree ])
+
+    system("git", "init", "-q", "-b", "main", worktree)
+    system("git", "-C", worktree, "config", "user.email", "test@example.com")
+    system("git", "-C", worktree, "config", "user.name", "Test")
+    File.write(File.join(worktree, "README.md"), "seed\n")
+    system("git", "-C", worktree, "add", "README.md")
+    system("git", "-C", worktree, "commit", "-q", "-m", "seed")
+
+    File.write(File.join(task_folder, "task.md"), <<~MD)
+      ---
+      slug: demo-260629-fixfb
+      ---
+
+      # Demo
+
+      <!-- REVIEW_WAITING pass=1 -->
+    MD
+    File.write(File.join(task_folder, "worktree.yml"), {
+      "path" => worktree,
+      "branch" => "demo-260629-fixfb"
+    }.to_yaml)
+    File.write(File.join(reviews, "code-review-01.md"), <<~MD)
+      ## High
+      - [x] Fix the nil guard
+    MD
+    File.write(File.join(reviews, "escalations-01.md"), <<~MD)
+      # Escalations for pass 01
+
+      _No escalations._
+    MD
+
+    task = Hive::Task.new(task_folder)
+    cfg = {
+      "worktree_root" => worktree_root,
+      "default_branch" => "main",
+      "review" => {
+        "max_passes" => 1,
+        "reviewers" => [],
+        "browser_test" => { "enabled" => false },
+        "fix" => { "guardrail" => { "enabled" => false } }
+      }
+    }
+    yield task, cfg, worktree
+  ensure
+    FileUtils.rm_rf(root) if root
+  end
+end
diff --git a/test/unit/stop_hook_installer_test.rb b/test/unit/stop_hook_installer_test.rb
index 71b2a57a..53a0bdaf 100644
--- a/test/unit/stop_hook_installer_test.rb
+++ b/test/unit/stop_hook_installer_test.rb
@@ -4,6 +4,8 @@ require "open3"
 require "shellwords"
 require "tmpdir"
 require "hive/stop_hook_installer"
+require "hive/claude_launcher"
+require "hive/task"
 
 class StopHookInstallerTest < Minitest::Test
   include HiveTestHelper
@@ -128,7 +130,7 @@ class StopHookInstallerTest < Minitest::Test
 
   def test_stop_hook_writes_result_json_and_done
     with_tmp_dir do |dir|
-      payload = %({"session_id":"abc","transcript_path":"/tmp/transcript.jsonl"})
+      payload = %({"session_id":"abc","transcript_path":"/tmp/transcript.jsonl"}\n\n)
       out, err, status = Open3.capture3({ "HIVE_TASK_STAGE_DIR" => dir }, HOOK, stdin_data: payload)
 
       assert status.success?, "stdout=#{out.inspect} stderr=#{err.inspect}"
@@ -137,6 +139,86 @@ class StopHookInstallerTest < Minitest::Test
     end
   end
 
+  def test_stop_hook_empty_stdin_writes_sentinel_json_and_done
+    with_tmp_dir do |dir|
+      out, err, status = Open3.capture3({ "HIVE_TASK_STAGE_DIR" => dir }, HOOK, stdin_data: "")
+
+      assert status.success?, "stdout=#{out.inspect} stderr=#{err.inspect}"
+      assert_equal "{\"hive_stop_hook\":\"empty_stdin\"}\n", File.read(File.join(dir, "result.json"))
+      assert File.exist?(File.join(dir, ".done"))
+    end
+  end
+
+  def test_stop_hook_touches_done_even_when_result_write_fails
+    with_tmp_dir do |dir|
+      # Make result.json an unwritable path by creating a directory where
+      # the file should be written; printf > dir/result.json then fails,
+      # but the EXIT trap must still create .done.
+      result_blocker = File.join(dir, "result.json")
+      FileUtils.mkdir_p(result_blocker)
+
+      _out, _err, status = Open3.capture3(
+        { "HIVE_TASK_STAGE_DIR" => dir },
+        HOOK,
+        stdin_data: '{"status":"ok"}'
+      )
+
+      refute status.success?, "result write into a directory must fail"
+      assert File.exist?(File.join(dir, ".done")),
+             "EXIT trap must touch .done even when result.json write fails"
+    end
+  end
+
+  def test_settings_command_writes_to_same_paths_as_claude_launcher
+    with_tmp_dir do |root|
+      stage_dir = File.join(root, ".hive-state", "stages", "6-review", "slug-260629-path")
+      FileUtils.mkdir_p(stage_dir)
+      task = Hive::Task.new(stage_dir)
+
+      settings = Hive::StopHookInstaller.settings(stage_dir)
+      command = settings.fetch("hooks").fetch("Stop").fetch(0).fetch("hooks").fetch(0).fetch("command")
+
+      # Execute the real settings command (with stubbed stdin) and assert
+      # the sentinel/result land exactly where ClaudeLauncher polls.
+      out, err, status = Open3.capture3(command, stdin_data: '{"status":"ok"}')
+      assert status.success?, "stdout=#{out.inspect} stderr=#{err.inspect}"
+
+      expected_done = Hive::ClaudeLauncher.done_path(task)
+      expected_result = Hive::ClaudeLauncher.result_path(task)
+      assert_equal File.join(stage_dir, ".done"), expected_done
+      assert_equal File.join(stage_dir, "result.json"), expected_result
+      assert File.exist?(expected_done)
+      assert File.exist?(expected_result)
+      assert_equal '{"status":"ok"}', File.read(expected_result)
+    end
+  end
+
+  def test_dual_install_both_point_hook_at_stage_dir_not_worktree
+    with_tmp_dir do |dir|
+      Dir.mktmpdir do |worktree|
+        paths = Hive::StopHookInstaller.install(stage_dir: dir, extra_dirs: [ worktree ])
+        assert_equal 2, paths.size
+
+        paths.each do |path|
+          data = JSON.parse(File.read(path))
+          command = data.fetch("hooks").fetch("Stop").first.fetch("hooks").first.fetch("command")
+          assert_includes command, "HIVE_TASK_STAGE_DIR=#{Shellwords.escape(dir)}"
+          refute_includes command, "HIVE_TASK_STAGE_DIR=#{Shellwords.escape(worktree)}"
+        end
+
+        # Running either installed command still writes into stage_dir.
+        command = JSON.parse(File.read(paths.last))
+                      .fetch("hooks").fetch("Stop").first
+                      .fetch("hooks").first.fetch("command")
+        out, err, status = Open3.capture3(command, stdin_data: '{"from":"worktree-cwd"}')
+        assert status.success?, "stdout=#{out.inspect} stderr=#{err.inspect}"
+        assert File.exist?(File.join(dir, ".done"))
+        assert_equal '{"from":"worktree-cwd"}', File.read(File.join(dir, "result.json"))
+        refute File.exist?(File.join(worktree, ".done"))
+      end
+    end
+  end
+
   def test_stop_hook_requires_stage_dir_env
     # Scrub HIVE_TASK_STAGE_DIR from the child env so the test is hermetic even
     # when the surrounding shell exports it (e.g. under the review harness);
diff --git a/test/unit/tmux_runner_test.rb b/test/unit/tmux_runner_test.rb
index 005bccda..a46699e6 100644
--- a/test/unit/tmux_runner_test.rb
+++ b/test/unit/tmux_runner_test.rb
@@ -282,14 +282,56 @@ class TmuxRunnerTest < Minitest::Test
     end
   end
 
-  def test_session_exists_returns_false_when_tmux_missing
+  def test_session_exists_raises_when_tmux_missing
     with_tmp_dir do |dir|
       runner = Hive::TmuxRunner.new(name: unique_name("missing-exists"), cwd: dir, tmux_bin: "missing-tmux-for-hive")
 
+      assert_raises(Hive::TmuxRunner::ExecutableMissing) { runner.session_exists? }
+    end
+  end
+
+  def test_session_exists_raises_on_transient_command_failure
+    with_tmp_dir do |dir|
+      fake = write_fake_tmux(dir, <<~SH)
+        #!/bin/sh
+        echo "temporary has-session failure" >&2
+        exit 1
+      SH
+      runner = Hive::TmuxRunner.new(name: unique_name("exists-failed"), cwd: dir, tmux_bin: fake)
+
+      error = assert_raises(Hive::TmuxRunner::CommandFailed) { runner.session_exists? }
+      assert_match(/temporary has-session failure/, error.message)
+    end
+  end
+
+  def test_session_exists_returns_false_only_for_confirmed_missing_session
+    with_tmp_dir do |dir|
+      fake = write_fake_tmux(dir, <<~SH)
+        #!/bin/sh
+        echo "can't find session: gone" >&2
+        exit 1
+      SH
+      runner = Hive::TmuxRunner.new(name: unique_name("exists-gone"), cwd: dir, tmux_bin: fake)
+
       refute runner.session_exists?
     end
   end
 
+  def test_session_exists_raises_on_probe_timeout
+    with_tmp_dir do |dir|
+      fake = write_fake_tmux(dir, <<~SH)
+        #!/bin/sh
+        exec sleep 5
+      SH
+      runner = Hive::TmuxRunner.new(name: unique_name("exists-timeout"), cwd: dir, tmux_bin: fake)
+
+      error = with_env("HIVE_TMUX_COMMAND_TIMEOUT_SEC" => "0.05") do
+        assert_raises(Hive::TmuxRunner::CommandTimedOut) { runner.session_exists? }
+      end
+      assert_match(/has-session/, error.message)
+    end
+  end
+
   def test_pane_pid_returns_nil_for_non_integer_output
     with_tmp_dir do |dir|
       fake = write_fake_tmux(dir, <<~SH)
